pub mod is_prime;

use std::{time::SystemTime,sync::mpsc,thread};
use num_bigint::BigUint;
use crate::is_prime::is_prime::is_prime;


fn main() {
    /* 
    let mut buffer = String::new();
    let stdin = io::stdin();
    print!("please enter the number to check: ");
    io::stdout().flush().expect("could not flush");
    stdin.read_line(&mut buffer).expect("could not read from stdin");
    buffer = buffer.trim().to_owned();
    
    let number = BigUint::parse_bytes(&buffer.as_bytes(), 10).expect("expected positive number");

    if is_prime(number.clone()) {
        println!("\n{number} is a prime");
    } else {
        println!("\n{number} is not a prime");
    }
    */

    let sys_time = SystemTime::now();

    // let (tx, rx) = mpsc::channel();

    // thread::spawn(move || {
    //     let val = String::from("hi");
    //     tx.send(val).unwrap();
    // });
    // TODO: multithreading

    let mut number = BigUint::from(0u8);
    let inc = BigUint::from(1u8);
    let mut primes: Vec<BigUint> = vec![];
    loop {
        number = number + inc.clone();
        if is_prime(number.clone()) {
            primes.push(number.clone());
            if primes.len() >= 1_000_000 {
                break;
            }
        }
    }

    let new_sys_time = SystemTime::now();
    let difference = new_sys_time.duration_since(sys_time)
    .expect("Clock may have gone backwards");

    println!("{:?}", primes);

    println!("And that's time: {difference:?}");


}
